# Kwil Header tool

An in-development command line tool for generating serialization code from C header files.

Kwil aims to be a non-intrusive drop-in (and if necessary drop-out) solution to automate the annoying task of writing deserialization and serialization code.

Currently aiming for json support, though adding (optional) support for other formats is strongly considered for implementing at a later time.


Features:

[x] Generate `*_json_length` and `*_to_json`functions for structs and enums marked with `KWIL_STRUCT()` or `KWIL_ENUM()`

[ ] Generate `*_from_json` functions for structs.

[ ] Dynamic array length specifiers (e.g: `KWIL_FIELD(LEN=13` or `KWIL_FIELD(LEN=src->field_length`)
