#ifndef _kwil_parse_H
#define _kwil_parse_H

#include <stdio.h>
#include "kwil_def.h"

// Open a header file and parse it for it's kwil types
extern void kwil_header_parse(struct kwil_header_t* self);
// Read a file until the end of struct definition.
extern void kwil_struct_parse(struct kwil_struct_t* self, FILE* file);
// Parse a field without checking custom types.
// Custom types will not be checked yet as they may not be known to kwel yet.
extern void kwil_field_parse(struct kwil_field_t* self, FILE* file);
// Parse an enum and it's possible values.
extern void kwil_enum_parse(struct kwil_enum_t* self, FILE* file);

#endif // !_kwil_parse_H
